if not SoundDevice then
	return
end

if not ModPath then
	return
end

local MyPath = ModPath


local CopySoundDevice
if SoundDevice and type(SoundDevice) == "userdata" then
	CopySoundDevice = getmetatable(SoundDevice)
end

Hoxtilicious = {}
Hoxtilicious.names = {
        control_bulldozer = "Hoxton bulldozer",
        control_cloaker = "Hoxton cloaker",
        control_shield = "Hoxton shield",
        control_taser = "Hoxton taser",
}

local tabt = {
	{
                name = "control_bulldozer",
		state = "control",
		unconfig_on_state = "assault"
	},
	{
                name = "control_cloaker",
		state = "control",
		unconfig_on_state = "assault"
	},
	{
                name = "control_shield",
		state = "control",
                unconfig_on_state = "assault"
	},
	{
                name = "control_taser",
		state = "control",
		unconfig_on_state = "assault"
	},
}

if CopySoundDevice then
	local _CopySoundDevice_set_state = CopySoundDevice.set_state
	function CopySoundDevice:set_state(type, state)
		if type == "wave_flag" then
			for index, data in pairs(tabt) do
				if data and Hoxtilicious.names[data.name] then					
					local mod_override_name = "assets/"..Hoxtilicious.names[data.name]
					local config = {}
					local Directory = MyPath..mod_override_name
					local file_path = Directory.."/soundbanks/streamed/regular_vox/"
					for i, file_name in pairs(file.GetFiles(file_path)) do
						if file_name:find(".stream") then
							local _f_name = file_name:gsub(".stream","")
							table.insert(config, {
								_meta = "stream",
								path = "soundbanks/streamed/regular_vox/".._f_name,
								force = true
							})
						end
					end
					if data.state == state then
						CustomPackageManager:LoadPackageConfig(Directory, config)
					elseif data.unconfig_on_state == state then
						CustomPackageManager:UnloadPackageConfig(config)
					end
				end
			end
		end
		return _CopySoundDevice_set_state(self, type, state)
	end
end